package pposRequest

import (
	"errors"
	"net/url"
)

func (that *PPOSClient) NewInfoPlatformMemberGetByMemberIdsRequest() *InfoPlatformMemberGetByMemberIdsRequest {
	return &InfoPlatformMemberGetByMemberIdsRequest{
		Request: Request{
			Client:     that,
			apiAddress: "/infoPlatform/member/getByMemberIds",
			publicParamsSlice: []string{
				"member_ids",
			},
		}}
}

type InfoPlatformMemberGetByMemberIdsRequest struct {
	Request
}

//会员信息
type MemberGetResponse struct {
	CompanyId         int64  `json:"company_id"`
	MemberId          int64  `json:"member_id"`
	WxOpenId          string `json:"wx_open_id"`
	MiniOpenId        string `json:"mini_open_id"`
	Name              string `json:"name"`
	Phone             string `json:"phone"`
	Avatar            string `json:"avatar"`
	Sex               int64  `json:"sex"`
	Birthday          string `json:"birthday"`
	Address           string `json:"address"`
	CredentialsType   int64  `json:"credentials_type"`
	CredentialsNumber string `json:"credentials_number"`
}

func (that *Request) SetMemberIds(memberIds string) *Request {
	that.initParams()
	that.params.Set("member_ids", memberIds)
	return that
}

//Params ...
func (that *InfoPlatformMemberGetByMemberIdsRequest) Params() (url.Values, error) {
	that.initParams()
	_params := that.params
	if that.publicParamsSlice != nil {
		for _, _v := range that.publicParamsSlice {
			if _params.Get(_v) == "" {
				return nil, errors.New(that.apiAddress + "缺少参数:" + _v)
			}
		}
	}
	return _params, nil

}

//Do ...
func (that *InfoPlatformMemberGetByMemberIdsRequest) Do() (*MemberGetResponse, error) {
	//返回data
	_data, _err := that.Client.GetData(that.apiAddress, that)
	if _err != nil {
		return nil, _err
	}
	//
	_info := new(MemberGetResponse)
	if _b, _ok := _data.(bool); _ok && !_b {
		//会员不存在
		return _info, nil
	}
	_mp, _ok := _data.(map[string]interface{})
	if !_ok {
		return nil, errors.New(that.apiAddress + "请求响应格式不正确,错误代码01")
	}
	if _err := that.ParseResponeMp(_info, _mp); _err != nil {
		return nil, errors.New(that.apiAddress + "请求响应格式化异常:" + _err.Error())
	}
	//返回结果
	return _info, nil
}
